﻿

--[[


		$title:			Natur Enemy Castbar [Softrix Rewrite]
		$version:		r20118 BETA
		$date:			11th November 2008
		
		$credits:		Natur Enemy Castbar [Softrix Rewrite] is a complete rewrite
						based on the addon by Naturfreund.  Credits also go to 
						Shadowed who is the author of the GTB bar library which I
						have modified for this addon.  The original unmodified GTB 
						library for the purpose of these credits is at:
						
						http://www.wowinterface.com/downloads/info10204-GTB-1.0.html
						
						
		
]]--


--
--	Global options, common to all characters.
--
NECB_GlobalOptions = {

	true,							-- NECB Enabled?
	true,							-- Anchors Visible?
	10, 300, "UP", 15, 300, 4,		-- x, y, dir, height, width, texture of primary bars.
	10, 360, "UP", 15, 300,	4,		-- x, y, dir, height, width, texture of cooldown bars.
	10, 380, "UP", 15, 300,	4,		-- x, y, dir, height, width, texture of cc bars bars.
	"font",							-- font used by the bars.
	true,							-- Show casts without target/focus.		[22]
	true, "Male", false,			-- Killing Blow Sounds? / Male / Always?
	false,							-- Split cooldowns, casts and cc?		[26]
	false,							-- Show My Cooldowns?
	true,							-- Show Target Cooldowns?
	true,							-- Show others CC spells?
	true,							-- Show DR timer?						[30]
	true,							-- Flash UI on Immune.
	true,							-- Flash UI on Resist.
	20,20,							-- Maxiumum bars to show, primary/cooldown
	true,							-- Play Sound on Immune					[35]
	false,							-- Play Sound on Resist
	true,							-- Play sound/warn on rogue detection.
	true,							-- Only show dots etc for my target/focus. 
	true,							-- Play Sound on paladin shield.
	true							-- Show everyones DR's around me.		[40]
	
};

--
--	Available Textures used by NECB.
--
NECB_Textures = {
	-- bar textures.
	"Interface\\Addons\\NECB\\Textures\\bantobar.tga",			-- [1]
	"Interface\\Addons\\NECB\\Textures\\charcoal.tga",			-- [2]
	"Interface\\Addons\\NECB\\Textures\\otravi.tga",			-- [3]
	"Interface\\Addons\\NECB\\Textures\\perl.tga",				-- [4]
	"Interface\\Addons\\NECB\\Textures\\smooth.tga",			-- [5]
	"Interface\\Addons\\NECB\\Textures\\smudge.tga",			-- [6]
	"Interface\\Addons\\NECB\\Textures\\striped.tga"			-- [7]
};

--
--	Internal Variables.
--
NECB_DebugMode = true;
NECB_SelectedGUID = nil;
NECB_RogueFireGUID = nil;

NECB_Red = "|cffff1010";
NECB_Green = "|cff00ff00";
NECB_Blue = "|cff0000ff";
NECB_White = "|cffffffff";
NECB_Gray = "|cff888888";
NECB_Yellow  = "|cffffff00";
NECB_Cyan   = "|cff00ffff";
NECB_Orange = "|cffff7000";
NECB_Gold = "|cffffcc00";
NECB_Mageta = "|cffe040ff";
NECB_ItemBlue = "|cff2060ff";
NECB_LightBlue = "|cff00e0ff";
NECB_LightGreen = "|cff60ff60";
NECB_LightRed = "|cffff5050";
NECB_SubWhite = "|cffbbbbbb";

-- small icon to the right of the bars indication
-- where a cast is coming from.
NECB_TargetGFX = "Interface\\Addons\\NECB\\Graphics\\NECB_Target.tga";
NECB_FocusGFX = "Interface\\Addons\\NECB\\Graphics\\NECB_Focus.tga";
NECB_DRGFX = "Interface\\Addons\\NECB\\Graphics\\NECB_DR.tga";

-- Casting targets storage.
NECB_CastingMobs = {};
-- Spells running storage, i.e. dots, cc etc.
NECB_SpellTimersRunning = {};
-- mobs_id, mobs_name, fire_time, duration, icon
NECB_DRTracking = {};	-- mobs tracked for DR
-- mob cooldown tracking.
NECB_CooldownTracking = {};

--
--		NECB_OnLoad()
--
function NECB_OnLoad()
	-- initialise events im interested in.
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	-- initialise command line
	SlashCmdList["NECB"] = NECB_Commandline;
	SLASH_NECB1="/necb";
end;

--
--	Command Line Parser
--
function NECB_Commandline(args)
	local lowerargs = strlower(args);				
	if(lowerargs == "debug") then
		if(NECB_DebugMode) then NECB_DebugMode = false;
		else NECB_DebugMode = true; end;
	else
		-- show options
		NECB_ProcessOptionsFrame();		-- update the frame controls.
		NECB_MainOptionsFrame:Show();
		
	end;
end;

--
--	Initialise Nature Enemy Castbar
--
function NECB_Initialise()
	
	-- wheres this client then?
	local client_area = GetLocale();		
	if(client_area == "enUS") then 
		NECB_Local_enUS();
	elseif(client_area == "frFR") then 
		NECB_Local_frFR();
	elseif(client_area == "deDE") then 
		NECB_Local_deDE();
	elseif(client_area == "koKR") then 
		NECB_Local_koKR();
	elseif(client_area == "zhCN") then 
		NECB_Local_zhCN();
	elseif(client_area == "zhTW") then 
		NECB_Local_zhTW();
	elseif(client_area == "ruRU") then 
		NECB_Local_ruRU();
	elseif(client_area == "esES") then 
		NECB_Local_enUS();
	elseif(client_area == "esMX") then 
		NECB_Local_esMX(); 
	end;

	-- Setup Softrix GTB Library
	NECB = LibStub:GetLibrary("Softrix-1.0");
	-- Main group
	NECBPrimaryGroup = NECB:RegisterGroup("Полоса применений", NECB_Textures[NECB_GlobalOptions[8]]);
	NECBPrimaryGroup:RegisterOnMove("NECB_PrimaryOnBarMove");
	NECBPrimaryGroup:SetInvert(true);					
	NECBPrimaryGroup:SetScale(1.0);
	NECBPrimaryGroup:SetWidth(NECB_GlobalOptions[7]);
	NECBPrimaryGroup:SetHeight(NECB_GlobalOptions[6]);
	NECBPrimaryGroup:SetDisplayGroup("");
	NECBPrimaryGroup:SetAnchorVisible(NECB_GlobalOptions[2]);
	NECBPrimaryGroup:SetBarGrowth(NECB_GlobalOptions[5]);		
	NECBPrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", NECB_GlobalOptions[3], NECB_GlobalOptions[4])
	-- Cooldown group
	NECBCooldownGroup = NECB:RegisterGroup("Перезарядки", NECB_Textures[NECB_GlobalOptions[14]]);
	NECBCooldownGroup:RegisterOnMove("NECB_CooldownOnBarMove");
	NECBCooldownGroup:SetInvert(true);					
	NECBCooldownGroup:SetScale(1.0);
	NECBCooldownGroup:SetWidth(NECB_GlobalOptions[13]);
	NECBCooldownGroup:SetHeight(NECB_GlobalOptions[12]);
	NECBCooldownGroup:SetDisplayGroup("");
	NECBCooldownGroup:SetAnchorVisible(NECB_GlobalOptions[2]);
	NECBCooldownGroup:SetBarGrowth(NECB_GlobalOptions[11]);		
	NECBCooldownGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", NECB_GlobalOptions[9], NECB_GlobalOptions[10])
	-- now ready for the on_changed to fire.  stops a lua error on startup!  =p
	NECB_SAFELOADCHECK = true;
	-- Display a welcome message showing version information.
	DEFAULT_CHAT_FRAME:AddMessage(NECB_LightBlue.."Natur Enemy Castbar (r20118) загружен! Для настроек введите /necb ."..NECB_White.." - Полностью переписал Michael Boyle c/o Softrix Studios @ www.softrix.co.uk.  Для поддержики посетите наш форум www.softrix.co.uk/forum/");
end;

--
--	Supporting Functions to save anchor postion.
--
function NECB_PrimaryOnBarMove(parent, x, y)
	NECB_GlobalOptions[3] = x
	NECB_GlobalOptions[4] = y
end;
function NECB_CooldownOnBarMove(parent, x, y)
	NECB_GlobalOptions[9] = x
	NECB_GlobalOptions[10] = y
end;

--
--	Main Event Handler
--
function NECB_EventHandler(event,...)

	-- check if my addon has been loaded then 
	-- initialise everything such as the bars.
	if(event == "ADDON_LOADED") then
		if(arg1 == "NECB") then
			NECB_Initialise();			-- Initialise Natur Addon.
		end;
	end;
		
	if(event == "PLAYER_TARGET_CHANGED") then
		NECB_SelectedGUID = UnitGUID("target");			-- grab targets guid.
		if(NECB_GlobalOptions[28]) then NECB_ShowTargetCooldowns(NECB_SelectedGUID); end;
		if(not(NECB_GlobalOptions[38])) then NECB_ShowTargetTimers(NECB_SelectedGUID); end;
		if(NECB_SelectedGUID) then
			NECB_RemoveExpiredCasts();					-- remove expired casts.
			ShowCastTracking(NECB_SelectedGUID);		-- any casts pending for this target?
		end;
	end;
	
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then
		-- someone is starting a cast
		if(arg2 == "SPELL_CAST_START") then
			if(not(arg3 == UnitGUID("player"))) then
				-- grab the icon and duration for this spell id.
				local _,_, icon,_,_,_, castTime,_,_ = GetSpellInfo(arg9);
				-- save this cast incase its not something i have selected
				-- and therefore will be able to show the duration of the
				-- cast (mid cast) if i make him my target.
				AddCastTracking(GetTime(), arg3, arg4, arg9, arg10, icon, castTime/1000);				
				-- is the cast from my target or focus.. setup icon.
				local targetFocus = nil;
				if(arg3 == UnitGUID("target")) then targetFocus = NECB_TargetGFX;
				elseif(arg3 == UnitGUID("focus")) then targetFocus = NECB_FocusGFX; end;
				-- do we want to display focus/target only or all?
				if(targetFocus or NECB_GlobalOptions[22]) then					
					NECBPrimaryGroup:SetInvert(true);
					if(castTime) then NECBPrimaryGroup:RegisterBar(arg9..arg3.."Применяет", arg10.." ("..arg4..")", castTime/1000, castTime/1000, icon, targetFocus); end;
				end;
			end;
		-- someone has made an instant cast such as a totem, sap, blind etc.
		elseif(arg2 == "SPELL_CAST_SUCCESS" or 	arg2 == "SPELL_SUMMON") then		-- "SPELL_SUMMON" added for totems
			if(not(NECB_DoesEntryExist(arg6, arg10)) and arg7) then
				local spell_id, duration, cooldown, pvp_dur, dr, cc,_,_= NECB_GetSpellInfo(arg9, arg6);
				if(spell_id) then
					-- we have a spell im interested in, read the spell icon info.
					local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
					-- now check if its mine.
					if(arg3 == UnitGUID("player")) then
						-- its my cast
						if(duration) then
							-- i have a duration, create the bar for my dots, renews etc.
							NECB_AddSpellTimer(arg6, arg7, arg3, arg4, arg9, arg10, duration, cooldown, GetTime(), nil, icon, arg3..arg9..arg6.."Cast");
						end;
						if(cooldown and NECB_GlobalOptions[27]) then	-- show my cooldowns?
							-- theres a cooldown on this cast. No need to 
							-- store it here if its my cooldown.
							NECBPrimaryGroup:SetInvert(false);
							NECBCooldownGroup:SetInvert(false);
							if(NECB_GlobalOptions[26]) then		-- seperated?
								NECBCooldownGroup:RegisterBar(arg9..arg3.."ПЗ", arg10.." (ПЗ)", cooldown, cooldown, icon);
							else
								NECBPrimaryGroup:RegisterBar(arg9..arg3.."ПЗ", arg10.." (ПЗ)", cooldown, cooldown, icon);
							end;
						end;
					else
						-- if ive detected a stealth, sprint etc from a hostile target please warn me!  =p
						if(NECB_GlobalOptions[37]) then		-- do i want to show a warning?
							if(arg9 == 1784 or arg9 == 1785 or arg9 == 1786 or arg9 == 1787 or
								arg9 == 2983 or arg9 == 8696 or arg9 == 11305) then
								if (CombatLog_Object_IsA(arg5, COMBATLOG_FILTER_HOSTILE_PLAYERS)) then
									-- come from a unfriendly mob, was it the previous one?
									if(not(arg3 == NECB_RogueFireGUID)) then
										NECB_RogueFireGUID = arg3;
										NECB_UIFlash("RED");
										local msg = string.format(NECB_ROGUE_WARNING, NECB_StripServer(arg4), arg10);
										DEFAULT_CHAT_FRAME:AddMessage(NECB_Red..msg);
										UIErrorsFrame:AddMessage(msg, 1.0, 0.0, 0.0, 53, 10);
									end;
								end;
							end;
						end;
					end;
				end;
			else
				-- if ive detected a vanish from a hostile target please warn me!  =p
				if(NECB_GlobalOptions[37]) then		-- do i want to show a warning?
					if(arg9 == 1856 or arg9 == 1857 or arg9 == 26889) then
						if (CombatLog_Object_IsA(arg5, COMBATLOG_FILTER_HOSTILE_PLAYERS)) then
							-- come from a unfriendly mob!
							if(not(arg3 == NECB_RogueFireGUID)) then
								NECB_RogueFireGUID = arg3;	
								NECB_UIFlash("RED");
								local msg = string.format(NECB_ROGUE_WARNING, NECB_StripServer(arg4), arg10);
								DEFAULT_CHAT_FRAME:AddMessage(NECB_Red..msg);
								UIErrorsFrame:AddMessage(msg, 1.0, 0.0, 0.0, 53, 10);
							end;
						end;
					end;
				end;
			end;			
		-- an aura was applied.
		elseif(arg2 == "SPELL_AURA_APPLIED") then
			if(not(NECB_DoesEntryExist(arg6, arg10))) then
				local spell_id, duration, cooldown, pvp_dur, dr, cc,_,_ = NECB_GetSpellInfo(arg9, arg6);
				if(arg3 == UnitGUID("player")) then	
					-- its my cast.
					if(duration) then
						if(arg3 == UnitGUID("player")) then
							local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
							NECB_AddSpellTimer(arg6, arg7, arg3, arg4, arg9, arg10, duration, cooldown, GetTime(), nil, icon, arg3..arg9..arg6.."Aura");
						end;
					end;
					-- does it have a cooldown?
					if(cooldown and NECB_GlobalOptions[27]) then
						-- its there 
						local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
						NECBPrimaryGroup:SetInvert(false);
						NECBCooldownGroup:SetInvert(false);
						if(NECB_GlobalOptions[26]) then	-- seperated?
							NECBCooldownGroup:RegisterBar(arg9..arg3.."ПЗ", arg10.." (ПЗ)", cooldown, cooldown, icon);
						else
							NECBPrimaryGroup:RegisterBar(arg9..arg3.."ПЗ", arg10.." (ПЗ)", cooldown, cooldown, icon);
						end;
					end;	
				else
					-- does this spell have a cooldown, if so save it if i need to!
					if(cooldown and arg4 and NECB_GlobalOptions[28]) then 
						local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
						NECB_TrackCooldown(arg3, arg4, arg9, arg10, GetTime(), cooldown, arg3..arg9.."MobCD", icon);
						NECB_ShowTargetCooldowns(arg3);	-- show here just incase i already have him targeted.
					end;
					-- it wasnt by me but if its a cc spell do i want to still monitor it?
					if(NECB_GlobalOptions[29] and cc) then
						if(duration) then
							local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
							NECB_AddSpellTimer(arg6, arg7.." ("..arg4..")", arg3, arg4, arg9, arg10, duration, cooldown, GetTime(), nil, icon, arg3..arg9..arg6.."Aura");
						end;
					end;					
				end;
			end;
		-- a cast failed for whatever reason.		
		elseif(arg2 == "SPELL_CAST_FAILED") then
			if(not(arg3 == UnitGUID("player"))) then
				NECBPrimaryGroup:UnregisterBar(arg9..arg3.."Применяет");
			end;
		-- fires when a spell is renewed on a target such as Shackle
		elseif(arg2 == "SPELL_AURA_REFRESH") then
			NECB_RefreshSpellEntry(arg6, arg10, arg1);
		elseif(arg2 == "SPELL_AURA_REMOVED") then
			NECB_RemoveSpellTimer(arg6, arg10);
			-- was this aura a DR mob of mine?
			local _,_,_,_, dr,_,_,_ = NECB_GetSpellInfo(arg9, arg6);
			local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(arg9);
			if(dr and arg6 and arg3 == UnitGUID("player") or dr and arg6 and NECB_GlobalOptions[40]) then
				NECB_StartExpireTimer(arg6, icon);
			end;
		elseif(arg2 == "SPELL_AURA_DISPELLED") then
			NECB_RemoveSpellTimer(arg6, arg10);		
		-- someone tried to apply a spell but it missed
		-- i.e. IMMUNE, EVADE or RESIST
		elseif(arg2 == "SPELL_MISSED") then
			if(arg4 == UnitName("player")) then
				-- it was my miss.
				local _,_,_,_, dr,cc,_,_ = NECB_GetSpellInfo(arg9, arg6);
				if(dr or cc) then
					if(arg12=="IMMUNE" and NECB_GlobalOptions[31]) then
						-- oh dear, reached end of DR and target is
						-- immune.. lets flash the screen giving
						-- a warning.
						NECB_UIFlash("RED");	-- flash screen red.
						local msg = string.format(NECB_IMMUNE_ANNOUNCE, arg7, arg10);
						DEFAULT_CHAT_FRAME:AddMessage(NECB_Red..msg);
						if(NECB_GlobalOptions[35]) then PlaySoundFile(NECB_SpellImmuneSND); end;
					elseif(arg12=="RESIST" and NECB_GlobalOptions[32]) then
						-- do we even want to warn this?
						NECB_UIFlash("RED");	-- flash screen red.
						local msg = string.format(NECB_RESISTED_ANNOUNCE, arg7, arg10);
						DEFAULT_CHAT_FRAME:AddMessage(NECB_Red..msg);
						if(NECB_GlobalOptions[36]) then PlaySoundFile(NECB_SpellResistedSND); end;
					end;
				end;								
			end;			
		elseif(arg2 == "UNIT_DIED") then
			-- not really usefull in pvp to accuracy 
			-- issues but monitor it anyway.
			NECB_DeleteDeadCooldowns(arg6);			-- remove dead cooldowns
			NECB_DeleteDeadCast(arg6);				-- remove dead casts
			NECB_RemoveExpiredCasts();				-- remove expired.
			NECB_RemoveDeadDR(arg6);				-- remove any DR timers for this target.
			NECB_RemoveSpellTimers(arg6);			-- remove all dots etc for this target.
		-- A mob just died!
		elseif(arg2 == "PARTY_KILL") then
			if(arg3 == UnitGUID("player")) then
				-- arg3 is me so i got the kill.. woot, do i want
				-- to play a killing blow sound if this mob gains
				-- me xp or honor?
				NECB_DeleteDeadCooldowns(arg6);			-- remove dead cooldowns
				NECB_FunPVPSounds(arg6);				-- remove any dead cooldowns
				NECB_RemoveExpiredCasts();				-- remove expired.
				NECB_RemoveDeadDR(arg6);				-- remove any DR timers for this target.
				NECB_DeleteDeadCast(arg6);				-- delete any dead casts.
			end;
		end;	-- END OF PARTY KILL	
	end;
		
end;

--
--	Strip server name from player.
--
function NECB_StripServer(name)
	name = string.match(name, "[^-]*");
	return(name);
end



-- ========================================= --
-- ===      CAST TRACKING FUNCTIONS      === --
-- ========================================= --

--
--	TABLE DETAILS
-- 
--	1..		fired time
--	2..		casters guid
--	3..		casters name
--	4..		spells id
--	5..		spells name
--	6..		spells icon
--	7..		duration of cast
--


--
--	Add Cast for tracking.
--
function AddCastTracking(fire_time, caster_id, caster_name, spell_id, spell_name, icon, duration)
	if(caster_name) then caster_name = NECB_StripServer(caster_name); end;
	tinsert(NECB_CastingMobs, {fire_time, caster_id, caster_name, spell_id, spell_name, icon, duration});
end;

--
--	Show a tracked cast (called by target change)
--
function ShowCastTracking(caster_id)
	for count,value in ipairs(NECB_CastingMobs) do
		if(value[2] == caster_id) then
			-- calculate time remaining since it was fired =p
			-- show the timer and the target icon since im obviously have it
			-- as my target or i wouldnt be here  =p
			local remainingTime = tonumber(value[7]) - (GetTime() - tonumber(value[1]));
			NECBPrimaryGroup:RegisterBar(value[2]..value[4], value[5].." ("..value[3]..")", remainingTime, remainingTime, value[6], NECB_TargetGFX);	
		end;
	end;
end;


--
--	Remove a dead casters tracking entries (if he exists)
--
function NECB_DeleteDeadCast(caster_id)
	for count,value in ipairs(NECB_CastingMobs) do
		if(value[2] == caster_id) then
			-- found the caster, delete it.
			tremove(NECB_CastingMobs, count);
		end;
	end;
end;

--
--	Cycle through and delete any expired casts
--
function NECB_RemoveExpiredCasts()
	for count,value in ipairs(NECB_CastingMobs) do
		local castTime = value[1];
		local timeNow = GetTime();
		local totaDur = timeNow - castTime;
		if(totaDur > (value[7]+15)) then	-- remove any casts which exist 15 sec after cast duration.
			tremove(NECB_CastingMobs, count);
		end;
	end;
end;

--
--	Clear all data
--
function NECB_ClearAllCasts()
	NECB_CastingMobs = nil;
end;


-- ================================================= --
-- ===      AURA APPLIED TRACKING FUNCTIONS      === --
-- ================================================= --

-- for dots, cc etc.

-- AURAS, CASTS OF MINE AND COOLDOWNS
--
--	1..		mobs id
--	2..		mobs name
--	3..		casters guid
--	4..		casters name
--	5..		spells id
--	6..		spells name
--	7..		duration
--	8..		cooldown
--	9..		fire time
--	10..	stack
--	11..	icon
--	12..	bars id
--


--
--	Add Spell for tracking.
--
function NECB_AddSpellTimer(mobs_id, mobs_name, caster_id, caster_name, spell_id, spell_name, duration, cooldown, fire_time, stack, icon, bar_id)
	-- Strip server name from player or mob
	if(casters_name) then casters_name = NECB_StripServer(casters_name); end;
	if(mobs_name) then mobs_name = NECB_StripServer(mobs_name); end;
	-- we only want to perform a DR if its a player.
	local guid = strsub(mobs_id, 1 ,5);
	if(bit.band(guid, 0x00F) == 0) then 
		-- do we have a dr for this spell?
		local _,_,_,_, dr,_,_,_ = NECB_GetSpellInfo(spell_id, mobs_id);
		if(dr) then
			-- spell has a dr, need to track it.
			local drTime = NECB_TrackDR(mobs_id, mobs_name, duration, icon);
			duration = drTime;		
		end;	
	end;
	tinsert(NECB_SpellTimersRunning, {mobs_id, mobs_name, caster_id, caster_name, spell_id, spell_name, duration, cooldown, fire_time, stack, icon, bar_id}); 
	NECBPrimaryGroup:SetInvert(true);
	if(mobs_name) then 	NECBPrimaryGroup:RegisterBar(bar_id, spell_name.."->"..mobs_name, duration, duration, icon);
	else NECBPrimaryGroup:RegisterBar(bar_id, spell_name, duration, duration, icon); end;
end;


--
--	Show Timers for a selected target
--
function NECB_ShowTargetTimers(mobs_id)
	for count,value in ipairs(NECB_SpellTimersRunning) do
		if(value[1] == mobs_id and value[1] == UnitGUID("target")) then	
			NECBPrimaryGroup:SetInvert(true);
			NECBPrimaryGroup:ShowBar(value[12]);
		else
			NECBPrimaryGroup:HideBar(value[12]);
		end;
	end;
end;


--
--	Remove all spell timers for a mob
--
function NECB_RemoveSpellTimers(mobs_id)
	for count,value in ipairs(NECB_SpellTimersRunning) do
		if(value[1] == mobs_id) then
			NECBPrimaryGroup:UnregisterBar(value[12]);				-- kill the bar.	
			tremove(NECB_SpellTimersRunning, count);				-- remove the entry
		end;
	end;
end;

--
--	Remove a selected spell on a selected mob
--
function NECB_RemoveSpellTimer(mobs_id, spell_name)
	if(not(spell_name)) then return(false); end;
	for count,value in ipairs(NECB_SpellTimersRunning) do
		if(value[1] == mobs_id and value[6] == spell_name) then
			NECBPrimaryGroup:UnregisterBar(value[12]);				-- kill the bar.
			tremove(NECB_SpellTimersRunning, count);				-- remove the entry
			return(true);	-- successful
		end;
	end;
	return(false);
end;

--
--	Does a spell and mob already exist?
--
function NECB_DoesEntryExist(mobs_id, spell_name)
	if(not(spell_name)) then return(false); end;
	for count,value in ipairs(NECB_SpellTimersRunning) do
		if(value[1] == mobs_id and value[6] == spell_name) then
			return(true);	
		end;
	end;
	return(false);
end;

--
--	Refresh an existing spell.  This will also refresh any combo,
--	DR etc.  Need to work on DR
--
function NECB_RefreshSpellEntry(mobs_id, spell_name, fire_time)
	if(not(spell_name)) then return(false); end;
	for count,value in ipairs(NECB_SpellTimersRunning) do
		if(value[1] == mobs_id and value[6] == spell_name) then
			value[9] = fire_time;
			-- we only want to perform a DR if its a player.
			local guid = strsub(mobs_id, 1 ,5);
			if(bit.band(guid, 0x00F) == 0) then 
				-- do we need to update the DR?
				local _,_,_,_, dr,_,_,_ = NECB_GetSpellInfo(value[5], mobs_id);
				if(dr) then
					-- spell has a dr, need to track it.
					local drTime = NECB_TrackDR(mobs_id, value[2], value[7], value[11]);
					value[7] = drTime;	
				end;
			end;
			NECBPrimaryGroup:SetInvert(true);
			if(value[2]) then NECBPrimaryGroup:RegisterBar(value[12], value[6].."->"..value[2], value[7], value[7], value[11]);
			else NECBPrimaryGroup:RegisterBar(value[12], value[6], value[7], value[7], value[11]); end;
			return(true);	-- successful
		end;
	end;
	return(false);
end;



-- ================================================= --
-- ===        TARGET COOLDOWNS FUNCTIONS         === --
-- ================================================= --

-- cooldown tracking

--
--	COOLDOWN TABLE
--
--	1..	caster id
--	2..	caster name
--	3..	spell id
--	4..	spell name
--	5..	fire time
--	6.. duration
--	7..	bar id
--	8.. icon
--

--
--	Add cooldown entry
--
function NECB_TrackCooldown(caster_id, caster_name, spell_id, spell_name, fire_time, duration, bar_id, icon)
	tinsert(NECB_CooldownTracking, {caster_id, caster_name, spell_id, spell_name, fire_time, duration, bar_id, icon});
end;

--
--	Clear out expired cooldowns.
--
function NECB_RemoveExpiredCooldown()
	for count,value in ipairs(NECB_CooldownTracking) do
		local castTime = value[5];
		local timeNow = GetTime();
		local totaDur = timeNow - castTime;
		if(totaDur > value[6]) then		-- remove anything after its expired.
			tremove(NECB_CooldownTracking, count);
		end;
	end;
end;

--
--	Show any cooldowns on selected target!
--
function NECB_ShowTargetCooldowns(caster_id)
	NECB_RemoveExpiredCooldown();	-- clear out anything old.
	for count,value in ipairs(NECB_CooldownTracking) do
		if(value[1] == caster_id and value[1] == UnitGUID("target")) then
			local remainingTime = tonumber(value[6]) - (GetTime() - tonumber(value[5]));
			if(NECB_GlobalOptions[26]) then		-- seperated?
				NECBCooldownGroup:RegisterBar(value[7], value[4].." (ПЗ "..value[2].."'а)", remainingTime, remainingTime, value[8]);	
			else
				NECBPrimaryGroup:RegisterBar(value[7], value[4].." (ПЗ "..value[2].."'а)", remainingTime, remainingTime, value[8]);	
			end;
		else
			if(NECB_GlobalOptions[26]) then NECBCooldownGroup:HideBar(value[7]); 
			else NECBPrimaryGroup:HideBar(value[7]); end;
		end;
	end;
end;


--
--	Clear out any cooldowns for a dead mob
--
function NECB_DeleteDeadCooldowns(caster_id)
	for count,value in ipairs(NECB_CooldownTracking) do
		if(value[1] == caster_id) then
			tremove(NECB_CooldownTracking, count);
		end;
	end;
end;


-- ================================================= --
-- ===        DIMINISH RETURNS FUNCTIONS         === --
-- ================================================= --

-- Diminish returns functions calculate duration of
-- a cc spell such as polymorph on a player in pvp..
-- for example, in a 18 sec period if you sheep the
-- following applies:

-- First:		10 sec.
-- Second:		5 sec
-- Third:		2.5 sec
-- Fourth:		Immune.

-- DR TABLE
--
--	1..	mobs_id
--	2..	mobs_name
--	3..	fire_time
--	4..	duration
--	5..	icon
--

--
--	Add/Modify an existing DR
--
function NECB_TrackDR(mobs_id, mobs_name, duration, icon)
	-- only track DR if its a human!
	-- before we add or modify, look and clear any expired DR
	NECB_ClearExpiredDR();
	for count,value in ipairs(NECB_DRTracking) do
		if(value[1] == mobs_id) then
			-- he already exists, read the existing duration
			local lastDur = value[4];
			lastDur = lastDur / 2;	-- half it.
			value[4] = lastDur;		-- write it back
			return(lastDur);		-- return it.
		end;
	end;
	-- if we get here it didnt exist.
	tinsert(NECB_DRTracking, {mobs_id, mobs_name, GetTime(), duration, icon});
	return(duration);
end;

--
--	Remove expired DR
--
function NECB_ClearExpiredDR()
	for count,value in ipairs(NECB_DRTracking) do
		if(value[1]) then
			local fireTime = value[3];
			local timeNow = GetTime();
			local totaDur = timeNow - fireTime;
			if(totaDur >= 18) then	-- remove it, its expired. 
				tremove(NECB_DRTracking, count);
			end;
		end;
	end;
end;

--
--	Show a DR expire timer.
--
function NECB_StartExpireTimer(mobs_id, icon)
	for count,value in ipairs(NECB_DRTracking) do
		if(value[1]==mobs_id) then
			-- this is in my DR list so create a DR expire timer.
			value[3] = GetTime();				-- update its time of dr fire
			NECBPrimaryGroup:SetInvert(false);
			if(NECB_GlobalOptions[30]) then	-- do we want these dr timers shown?
				if(NECB_GlobalOptions[26]) then		-- seperated..?
					NECBCooldownGroup:RegisterBar(value[1], value[2].." (УЭ)", 18, 18, icon, NECB_DRGFX);
				else
					NECBPrimaryGroup:RegisterBar(value[1], value[2].." (УЭ)", 18, 18, icon, NECB_DRGFX);
				end;
			end;
		end;
	end;
end;

--
--	Remove a DR for something that dies, just keeps things tidy  =p
--
function NECB_RemoveDeadDR(mobs_id)
	for count,value in ipairs(NECB_DRTracking) do
		if(value[1]==mobs_id) then
			NECBPrimaryGroup:UnregisterBar(mobs_id);
			tremove(NECB_DRTracking, count);
		end;
	end;
end;
